/* MCS-512 Final project
Asma Ghareeb
*/
 

set more off
set more on

clear

cd "C:\Users\alsha\OneDrive\Documents\PhD IIT\MSC 512\Final Project II"
use aee2be8374c8147c.dta, clear
*describe the dataset*/


// 1. exclude "financial" firms, with Standard Industrial Classification (SIC) codes between 6000 and 6999
drop if gvkey >=6000 & gvkey<=6999
//(11,862 observations deleted)



// 2. observation between 1971 and 1994 
keep if fyear >=1971 & fyear <=1994
// (103,631 observations deleted)
 
 
// 3. ** exclude utilities "udel - liberalized pepreciaton code"
drop  udpl 

// 4. we exclude American Depository Receipts (ADRs), and Firms designated as pre-FASB.
drop adrr 

//5. **We exclude firms with nonpositive sales for the years in which they have nonpositive sales " sales/turnover(Net)"

 drop if sale <0
 //(2,928 observations deleted)
 

  drop if sale==. 
  //(33,849 observations deleted)
  
  save MSC512_FINAL_PROJECT, replace
  
  cd "C:\Users\alsha\OneDrive\Documents\PhD IIT\MSC 512\Final Project II\FINAL"

//Load the data
insheet using "MSC512_FINAL_II.csv",clear


 //Measuring of variables//

 ** 1. Cash/assets 
** Assets in the denominators of variables are calculated as assets "at" less cash and marketable securities "che"

gen assets = at - che 
//(674 missing values generated)


**Cash/assets 
gen cash_assets= ch/assets
//(60,202 missing values generated)


** 2. Generate variable Truncated/assets 
gen Truncated_assets=cash_assets
// (60,202 missing values generated)

replace Truncated_assets=1 if Truncated_assets>=1 & !missing(Truncated_assets) 
//(2,619 real changes made)

** 3. Generate Size is defined as the natural logarithm of assets
gen size = ln(assets)
drop if assets==.
//(24,288 missing values generated)


** 4. Generate variable The market-to-book ratio is measured as the book value of assets (at) , less the book value of equity (ceq), plus the market value of equity (csho*prcc_f), divided by assets

gen market_to_book = (at - ceq + (csho*prcc_f) )/ assets

//(39,803 missing values generated)

** 5. Generate variable R&D/sales
gen R_D_sales = xrd/sale 

//(94,342 missing values generated) 

** 6.  Generate variable Cash flow is defned as earnings before interest and taxes, but before depreciation and amortization, less interest, taxes, and common dividends.  

gen cashflow_asset = (oibdp - xint - txt - dv - cdvc)/assets


** 7.  Generate variable Net working capital without cash 
gen net_working_capital = (wcap-ch)/assets
//(43,523 missing values generated)

** 8. Generate variable Capital expenditures/assets
gen capital_expenditures = capx/ assets
//(10,363 missing values generated)

** 9. Generate variable Acquisitions/assets
gen Acquisitions_assets= aqc / assets
// (23,096 missing values generated)

** 10. Generate variable Payout to shareholders is the sum of cash dividends over assets and stock repurchases over assets
gen payout_to_shareholders = (dv/assets) + (prstkcc/assets)

//(158,814 missing values generated) 

** 11. Generate variable  Industry sigma

gen industry_sigma = optvol 
//(166,459 missing values generated)

** 12.Total leverage is total debt over total assets.
gen total_leverage = (dltt + dlc - che) /at
//(1,347 missing values generated)

findit rmiss2 
**Install the univar function
ssc install univar

**Use the univar function to replicate Table 1
univar cash_assets Truncated_assets size R_D_sales market_to_book  cashflow_asset net_working_capital capital_expenditures Acquisitions_assets payout_to_shareholders industry_sigma total_leverage  

